using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Objects;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;
using Microsoft.Surface;
using Microsoft.Surface.Presentation;
using Microsoft.Surface.Presentation.Controls;
using OficinaTuristicaFE.Controls;
using DAL;
using Shared;
using System.IO;
using InfoStrat.VE;
using InfoStrat.VE.NUI;
using System.Collections;
using System.Windows.Media.Animation;
using System.Threading;

namespace OficinaTuristicaFE
{
    /// <summary>
    /// Interaction logic for SurfaceWindow1.xaml
    /// </summary>
    public partial class ServiceList : SurfaceWindow
    {
        

        ///// <summary>
        ///// Boolean to know if the containerlist is already loaded
        ///// </summary>
        //bool containerAlreadyLoad;

        /// <summary>
        /// List with all the elements that appears in the different containers
        /// </summary>
        List<Item> containerlist = new List<Item>();
        
        ///<sumary>
        /// Reference to DAL component
        ///</sumary>
        private DataAccessLayer dal;
        
        /// <summary>
        /// Serialized information of the VCard
        /// </summary>       
        string VCardinformation;        
        
        /// <summary>
        /// Default constructor.
        /// </summary>
        public ServiceList()
        {
            InitializeComponent();
            
            AddActivationHandlers();
            ResourceDictionary rd = new ResourceDictionary();
            rd.Source = App.Language;
            this.Resources.MergedDictionaries.Add(rd);
        }

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);
            LoadContanier();           
        }
        
        /// <summary>
        /// Occurs when the window is about to close. 
        /// </summary>
        /// <param name="e"></param>
        protected override void OnClosed(EventArgs e)
        {
            base.OnClosed(e);

            // Remove handlers for Application activation events
            RemoveActivationHandlers();
        }

        /// <summary>
        /// Adds handlers for Application activation events.
        /// </summary>
        private void AddActivationHandlers()
        {
            // Subscribe to surface application activation events
            ApplicationLauncher.ApplicationActivated += OnApplicationActivated;
            ApplicationLauncher.ApplicationPreviewed += OnApplicationPreviewed;
            ApplicationLauncher.ApplicationDeactivated += OnApplicationDeactivated;
        }

        /// <summary>
        /// Removes handlers for Application activation events.
        /// </summary>
        private void RemoveActivationHandlers()
        {
            // Unsubscribe from surface application activation events
            ApplicationLauncher.ApplicationActivated -= OnApplicationActivated;
            ApplicationLauncher.ApplicationPreviewed -= OnApplicationPreviewed;
            ApplicationLauncher.ApplicationDeactivated -= OnApplicationDeactivated;
        }

        /// <summary>
        /// This is called when application has been activated.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OnApplicationActivated(object sender, EventArgs e)
        {
            //TODO: enable audio, animations here          
            
        }

        /// <summary>
        /// This is called when application is in preview mode.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OnApplicationPreviewed(object sender, EventArgs e)
        {
            //TODO: Disable audio here if it is enabled

            //TODO: optionally enable animations here
        }

        /// <summary>
        ///  This is called when application has been deactivated.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OnApplicationDeactivated(object sender, EventArgs e)
        {
            //TODO: disable audio, animations here
        }

        private void LoadContanier()
        {
            /// <summary>
            /// Variables to define the orientation and the initial position of the containers
            /// </summary>
            Point centerPrivateServices = new Point(200, 200);
            int orientationPrivateServices = -10;
            Point centerPublicServices = new Point(800, 200);
            int orientationPublicServices = 10;
            ThreadPool.QueueUserWorkItem((o) =>
            {
                dal = new DataAccessLayer();
                List<GroupsSet> groups = new List<GroupsSet>();
                try
                {
                    groups = dal.GetServiceList();
                }
                catch (Exception ex)
                {
                    Microsoft.Surface.UserNotifications.RequestNotification((string) this.Resources["15"],(string) this.Resources["16"]);
                }                

                foreach (GroupsSet groupSetItem in groups)
                {

                    Dispatcher.BeginInvoke((Action<GroupsSet>)((item) =>
                    {                        
                        Viewbox myView = new Viewbox();
                        ScatterViewItem svi = new ScatterViewItem();
                        Container contenedor = new Container();
                        contenedor.ServiceName.Content = item.Name;
                        contenedor.itemSelected += new EventHandler<ItemEventArgs>(contenedor_itemSelected);
                        //  contenedor.SelectionChanged += new SelectionChangedEventHandler(Container_SelectionChanged);
                        contenedor.ShowAllOnMap.Click += new RoutedEventHandler(ShowAllOnMapClick);
                        contenedor.ShowAllOnMapClick += new RoutedEventHandler(contenedor_ShowAllOnMapClick);    
                        AddContainerItems(contenedor, dal);
                        myView.Child = contenedor;
                        svi.Content = myView;
                        svi.MaxHeight = 425;
                        svi.MinHeight = 275;
                        svi.MaxWidth = 325;
                        svi.MinWidth = 225;
                        svi.Height = 275;
                        svi.Width = 225;

                        if (item.Name == "Services" || item.Name == "Sports" || item.Name == "Lodging" || item.Name == "Bars, Restaurants & Pubs" || item.Name == "Shopping")
                        {
                            orientationPrivateServices += 5;
                            centerPrivateServices.X = centerPrivateServices.X + 10;
                            centerPrivateServices.Y = centerPrivateServices.Y + 40;
                            svi.Center = centerPrivateServices;
                            svi.Orientation = orientationPrivateServices;
                        }
                        else if (item.Name == "Points Of Tourist Interest" || item.Name == "Routes" || item.Name == "List of interest phone numbers" || item.Name == "Transport" || item.Name == "Leisure")
                        {
                            orientationPublicServices -= 5;
                            centerPublicServices.X = centerPublicServices.X - 10;
                            centerPublicServices.Y = centerPublicServices.Y + 40;
                            svi.Center = centerPublicServices;
                            svi.Orientation = orientationPublicServices;
                        }
                            
                        MainScatterView.Items.Add(svi);

                    }), groupSetItem);
                }
            });
        }

        void contenedor_ShowAllOnMapClick(object sender, RoutedEventArgs e)
        {
            List<Item> items = (List<Item>)((Control)sender).DataContext;
        }

        private void contenedor_itemSelected(object sender, ItemEventArgs e)
        {

            Point scatterOffset = new Point();
            Point scatterCenter = new Point();
            Container serviceSelected = sender as Container;
            if (serviceSelected != null)
            {
                Type m = e.DirectlyOver.GetType();// Contact.DirectlyOver.GetType();

                FrameworkElement c = e.DirectlyOver as FrameworkElement;
                if (c != null)
                {
                    Item itemSelected = c.DataContext as Item;
                    if (itemSelected != null)
                    {
                        ScatterViewItem svi = new ScatterViewItem();
                        itemSelected = dal.GetItemDetails(serviceSelected.tipoServicio, itemSelected.CompanyName, App.LanguageItem);

                        foreach (ScatterViewItem item in MainScatterView.Items)
                        {
                            m = item.Content.GetType();
                            if (m.Name == "Viewbox")
                            {
                                m = ((Viewbox)item.Content).Child.GetType();
                                if (m.Name == "BusinessCard")
                                {
                                    if (itemSelected.CompanyName.ToString() == ((BusinessCard)((Viewbox)item.Content).Child).Title.Content.ToString()) //PAU: Quiere decir que el elemento ya existe y no hay que volver a ponerlo
                                    {
                                        svi = item;
                                        scatterOffset.X = ((ScatterViewItem)((Viewbox)serviceSelected.Parent).Parent).ActualWidth / 2;
                                        scatterCenter.X = e.Contact.GetCenterPosition(this).X + scatterOffset.X;
                                        scatterCenter.Y = e.Contact.GetCenterPosition(this).Y;
                                        svi.Center = scatterCenter;
                                        svi.Orientation = ((ScatterViewItem)((Viewbox)serviceSelected.Parent).Parent).Orientation;
                                        svi.IsActive = true; // Pone el scatterview encima de todos los dems items    
                                        return;
                                    }
                                }
                            }
                        }
                        BusinessCard VCard = new BusinessCard() { DataContext = itemSelected };
                        //VCard.DataContext = itemSelected;
                        VCard.Image = ImageFromBuffer(itemSelected.Image);
                        VCard.click += new RoutedEventHandler(ShowOnMap_Click);
                        VCard.closeClick += new RoutedEventHandler(VCard_closeClick);
                        VCard.mailClick += new RoutedEventHandler(VCard_mailClick);
                        VCard.printClick += new RoutedEventHandler(VCard_printClick);
                        VCard.StyleSuffix = serviceSelected.tipoServicio;
                        Viewbox myView = new Viewbox();
                        myView.Child = VCard;
                        svi.Content = myView;
                        svi.MaxHeight = 250;
                        svi.MinHeight = 100;
                        svi.MaxWidth = 450;
                        svi.MinWidth = 200;
                        svi.Height = 200;
                        svi.Width = 400;
                        scatterOffset.X = ((ScatterViewItem)((Viewbox)serviceSelected.Parent).Parent).ActualWidth / 2;
                        scatterCenter.X = e.Contact.GetCenterPosition(this).X + scatterOffset.X;
                        scatterCenter.Y = e.Contact.GetCenterPosition(this).Y;
                        svi.Center = scatterCenter;
                        svi.Orientation = ((ScatterViewItem)((Viewbox)serviceSelected.Parent).Parent).Orientation;
                        svi.IsActive = true; // Pone el scatterview encima de todos los dems items                     
                        MainScatterView.Items.Add(svi);
                    }
                }
            }
        }

        private void VCard_mailClick(object sender, RoutedEventArgs e)
        {
            PrintMail((BusinessCard)sender);
            ScatterEnterMail.Visibility = System.Windows.Visibility.Visible;
            enterMailAddress.Focus();
            enterMailAddress.KeyDown += new KeyEventHandler(enterMailAddress_KeyDown);
        }

        void enterMailAddress_KeyDown(object sender, KeyEventArgs e)        
        {
            if (e.Key.ToString() == "Return") 
            {
                SendMail();
                enterMailAddress.Clear();
            }
        }

        private void PrintMail(BusinessCard businessCard)
        {            
            VCardinformation = businessCard.Title.Content + "\n" + ((Item)businessCard.DataContext).Description + "\n" + businessCard.Telefono.Text + "\n"
                + businessCard.Direccion.Text + "\n" + businessCard.Mail.Text;
        }

        private void VCard_printClick(object sender, RoutedEventArgs e)
        {
            try
            {
                PrintBusinessCard((BusinessCard)sender);
            }
            catch (Exception ex)
            {
                Microsoft.Surface.UserNotifications.RequestNotification((string)this.Resources["23"], (string)this.Resources["24"]);
            }
        }

        public static void PrintBusinessCard(BusinessCard businessCard)
        {
            string VCarPrintdInformation;
            VCarPrintdInformation = businessCard.Title.Content + "\n" + ((Item)businessCard.DataContext).Description + "\n" + businessCard.Telefono.Text + "\n"
                + businessCard.Direccion.Text + "\n" + businessCard.Mail.Text + "\n\n" + "Ajuntament de Son Servera";
            Shared.PrintRoute print = new PrintRoute() { stringToPrint = VCarPrintdInformation };
            print.DoPrint();
        }


        private void MailSendButton_Click(object sender, RoutedEventArgs e)
        {
            SendMail();
            enterMailAddress.Clear();
        }

        private void SendMail()
        {
            ScatterEnterMail.Visibility = System.Windows.Visibility.Hidden;

            Storyboard sendMailStory = (Storyboard)this.Resources["SendMailAnimation"];
            //sendMailStory.Stop();
            sendMailStory.Begin();
            Storyboard success = (Storyboard)this.Resources["CheckAnimatio"];
            Storyboard failure = (Storyboard)this.Resources["CrossAnimation"];
            success.Stop();
            failure.Stop();
            bool isSuccess = false;
           // MailAnimcionGrid.Visibility = System.Windows.Visibility.Visible;

            //starts the mail send in a new thread
            System.Threading.ThreadPool.QueueUserWorkItem((o) =>
            {
                try
                {
                    Shared.Emailer.SendMessage((string)o, "Business Card Information", VCardinformation, OficinaTuristicaFE.Properties.Settings.Default.useSSL);
                    isSuccess = true;
                }
                catch (Exception ex)
                {
                    isSuccess = false;
                }
                finally
                {

                    //return to the windows thread using the dispatcher
                    App.Current.Dispatcher.BeginInvoke(new System.Threading.ThreadStart(() =>
                    {
                        sendMailStory.Stop();
                        MailAnimcionGrid.Visibility = System.Windows.Visibility.Hidden;

                    }));
                }

                //return to the windows thread using the dispatcher
                App.Current.Dispatcher.BeginInvoke(new System.Threading.ThreadStart(() =>
                {
                    if (isSuccess)
                    {
                        failure.Stop();
                        success.Begin();
                    }
                    else
                    {
                        success.Stop();
                        failure.Begin();
                    }
                }));
            }, enterMailAddress.Text); 
        }


        private void ShowAllOnMapClick(object sender, RoutedEventArgs e)
        {
            List<Item> itemListComplete = new List<Item>();
            Control item = sender as Control;
            itemListComplete = (List<Item>)item.DataContext;
            showMap(itemListComplete);
        }

        private void VCard_closeClick(object sender, RoutedEventArgs e)
        {
            BusinessCard vCardSelectedToClose = sender as BusinessCard;
            for (int i = 0; i < MainScatterView.Items.Count; i++)
            {
                Type m = ((ScatterViewItem)MainScatterView.Items[i]).Content.GetType();
                if (m.Name == "Viewbox")
                {
                    m = ((Viewbox)((ScatterViewItem)MainScatterView.Items[i]).Content).Child.GetType();
                    if (m.Name == "BusinessCard")
                    {
                        if (((Item)((BusinessCard)((Viewbox)((ScatterViewItem)MainScatterView.Items[i]).Content).Child).DataContext).CompanyName == ((Item)vCardSelectedToClose.DataContext).CompanyName)
                        {
                            MainScatterView.Items.Remove(MainScatterView.Items[i]);
                            return;
                        }
                    }
                }
            }
        }
        private void ShowOnMap_Click(object sender, RoutedEventArgs e)
        {
            List<Item> itemList = new List<Item>();
            BusinessCard vCardSelected = sender as BusinessCard;
            itemList.Add((Item)vCardSelected.DataContext);
            showMap(itemList);
        }

        public static ImageSource ImageFromBuffer(Byte[] bytes)
        {
            BitmapImage image = new BitmapImage();
            if (bytes != null)
            {
                MemoryStream stream = new MemoryStream(bytes);
                image.BeginInit();
                image.CreateOptions = BitmapCreateOptions.IgnoreColorProfile; //Nos prevenimos de archivos de imagen corruptos.
                image.StreamSource = stream;
                //image.StreamSource.Seek(0, System.IO.SeekOrigin.Begin);
                try
                {
                    image.EndInit();
                }
                catch (System.ArgumentException ex)
                {
                    //Microsoft.Surface.UserNotifications.RequestNotification((string) Resources["17"], (string) Resources["18"]);
                }
            }
            return image;
        }


        private void AddContainerItems(Container contenedor, DataAccessLayer dal)
        {        

            switch (contenedor.ServiceName.Content.ToString())
            {
                case "Services":
                    {                        
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "2");
                        try
                        {
                            containerlist = dal.GetPrivateServiceItems();
                        }
                        catch
                        {
                            Microsoft.Surface.UserNotifications.RequestNotification("Base de datos no disponible", "Contacte con informacin");
                        }
                        contenedor.tipoServicio = "PrivateServices";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }                        
                        contenedor.StyleSuffix = "_Services";
                        contenedor.publicOrPrivate = 0;
                        contenedor.DataContext = containerlist;
                        break;
                    }

                case "Sports":
                    {                       
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "3");
                        containerlist = dal.GetSportsItems();
                        contenedor.tipoServicio = "Sports";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Sports";
                        contenedor.publicOrPrivate = 0;
                        contenedor.DataContext = containerlist;
                    }
                    break;

                case "Lodging":
                    {                       
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "4");
                        containerlist = dal.GetLodgingItems();
                        contenedor.tipoServicio = "Lodging";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Lodging";
                        contenedor.publicOrPrivate = 0;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Bars, Restaurants & Pubs":
                    {                        
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "5");
                        containerlist = dal.GetBarsItems();
                        contenedor.tipoServicio = "Bars_Restaurants";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Restaurant";
                        contenedor.publicOrPrivate = 0;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Leisure":
                    {                        
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "6");
                        containerlist = dal.GetLeisureItems();
                        contenedor.tipoServicio = "Leisure";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;

                        }
                        contenedor.StyleSuffix = "_Leisure";
                        contenedor.publicOrPrivate = 1;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Shopping":
                    {                        
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "7");
                        containerlist = dal.GetShoppingItems();
                        contenedor.tipoServicio = "Shopping";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Shopping";
                        contenedor.publicOrPrivate = 0;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Points Of Tourist Interest":
                    {
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "8");
                        containerlist = dal.GetTouristAttractionsItems();
                        contenedor.tipoServicio = "PointsOfTouristInterest";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_TouristInterest";
                        contenedor.publicOrPrivate = 1;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Routes":
                    {
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "9");
                        containerlist = dal.GetRoutesItems();
                        contenedor.tipoServicio = "Routes";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Route";
                        contenedor.publicOrPrivate = 1;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "List of interest phone numbers":
                    {
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "10");
                        containerlist = dal.GetTelephonesItems();
                        contenedor.tipoServicio = "TelephoneOfInterest";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Telephone";
                        contenedor.publicOrPrivate = 1;
                        contenedor.DataContext = containerlist;                        
                    }
                    break;

                case "Transport":
                    {
                        contenedor.ServiceName.SetResourceReference(Label.ContentProperty, "11");
                        containerlist = dal.GetTransportItems();
                        contenedor.tipoServicio = "Transport";
                        for (int i = 0; i < containerlist.Count; i++)
                        {
                            containerlist[i].serviceType = contenedor.tipoServicio;
                        }
                        contenedor.StyleSuffix = "_Transports";
                        contenedor.publicOrPrivate = 1;
                        contenedor.DataContext = containerlist;                        
                    }
                    break; 
            }   
        }       

        private void BackToLanguageSelection_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
           
        }

        Map map;
        object mapLocker = new object();

        //private void ScatterViewItem_ContactTapGesture(object sender, ContactEventArgs e)
        //{

        //    showMap(null);
        //}

        private void showMap(List<Item> itemList)
        {
            if (map == null)
            {
                lock (mapLocker)
                {
                    if (map == null)
                    {
                        map = new Map() { items = itemList };
                        map.Closed += new EventHandler(map_Closed);
                        map.ShowDialog();
                    }
                }
            }
        }

        void map_Closed(object sender, EventArgs e)
        {
            lock (mapLocker)
            {
                map = null;
            }
        }

        private void CloseEnterMailAddress_Click(object sender, RoutedEventArgs e)
        {
            ScatterEnterMail.Visibility = System.Windows.Visibility.Hidden;
        }

       
        private void Reorganize_Click(object sender, RoutedEventArgs e)
        {
            Type m;

            /// <summary>
            /// Variables to define the orientation and the initial position of the containers
            /// </summary>
            Point centerPrivateServices = new Point(200, 200);
            int orientationPrivateServices = -10;
            Point centerPublicServices = new Point(800, 200);
            int orientationPublicServices = 10;
            
            ScatterViewItem[] itemsToRemove=new ScatterViewItem[MainScatterView.Items.Count];
            MainScatterView.Items.CopyTo(itemsToRemove, 0);

            foreach (ScatterViewItem item in itemsToRemove)
            {
                m = item.Content.GetType();
                if (m.Name == "Viewbox")
                {
                    m = ((Viewbox)((ScatterViewItem)item).Content).Child.GetType();
                    if (m.Name == "BusinessCard")
                    {
                        MainScatterView.Items.Remove(item);
                    }
                    else if (m.Name == "Container")
                    {
                        MainScatterView.Items.Remove(item);
                        item.MaxHeight = 425;
                        item.MinHeight = 275;
                        item.MaxWidth = 325;
                        item.MinWidth = 225;
                        item.Height = 275;
                        item.Width = 225;

                        if (((Container)((Viewbox)((ScatterViewItem)item).Content).Child).publicOrPrivate == 0)
                        {
                            orientationPrivateServices += 5;
                            centerPrivateServices.X = centerPrivateServices.X + 10;
                            centerPrivateServices.Y = centerPrivateServices.Y + 40;
                            item.Center = centerPrivateServices;
                            item.Orientation = orientationPrivateServices;
                        }
                        else
                        {
                            orientationPublicServices -= 5;
                            centerPublicServices.X = centerPublicServices.X - 10;
                            centerPublicServices.Y = centerPublicServices.Y + 40;
                            item.Center = centerPublicServices;
                            item.Orientation = orientationPublicServices;
                        }
                        MainScatterView.Items.Add(item);
                    }
                }
            }           
           // LoadContanier();
        }
    }
}